set sock {}
array set client {}
set tcl_precision 14
proc StartServer { port } {
	global sock
	if { $sock != {} } {
		return -code error "Already started"
	}
	set sock [ socket -server Incoming $port ]
	return $sock
}
proc Incoming { channel clientAddr clientPort } {
	global client
	set client($channel) [ list $clientAddr $clientPort ]
	fconfigure $channel -translation crlf -buffering line -blocking 0
	puts $channel "Welcome stranger!"
	flush $channel
	fileevent $channel readable [ list Reader $channel ]
}
proc Reader { channel } {
	global client
	if [ catch { set text [ gets $channel ] } ] {
		close $channel
		catch { unset client($channel) }
		return
	}
	if { $text == "quit" || [ eof $channel ] } {
		close $channel
		catch { unset client($channel) }
		return
	}
	if { $text != "" } {
		if [ catch { puts $channel "You say $text. Say quit!" } ] {
			close $channel
			catch { unset client($channel) }
			return
		}
		flush $channel
	}
}
proc StopServer {} {
	global sock
	global client
	catch { close $sock }
	foreach channel [ array names client ] {
		catch { close $channel }
	}
	array unset client
	set sock {}
	array set client {}
}
proc SendMsg { msg } {
	global client
	#set text [ join $msg " " ]
	foreach channel [ array names client ] {
		puts $channel $msg
	}
}
