//+------------------------------------------------------------------+
//|                                                  Version.mqh.mq4 |
//|                                                Maxim A.Kuznetsov |
//|                                                      luxtrade.tk |
//+------------------------------------------------------------------+
#property copyright "Maxim A.Kuznetsov"
#property link      "luxtrade.tk"
#property version   "1.00"
#property strict

#include <ATcl\\ATcl.mqh>

void OnStart()
{
  PrintFormat("ATcl version: %s",ATcl_Version());
  ATcl_OnInit();
  ATcl *tcl=new ATcl;
  if (tcl!=NULL && tcl.Ready()) {
    PrintFormat("Tcl version: %f",tcl.DoubleEval("info tclversion"));
    PrintFormat("Tcl pathLevel: %s",tcl.StringEval("set tcl_patchLevel"));
    PrintFormat("Tcl library: %s",tcl.StringEval("info library"));
    PrintFormat("    auto_path: %s",tcl.StringEval("set auto_path"));
    Tcl_Obj names=tcl.Ref(tcl.ObjEval("array names tcl_platform"));
    Tcl_Obj tcl_platform=tcl.Ref(tcl.Obj("tcl_platform"));
    int total=tcl.Count(names);
    for(int t=0;t<total;t++) {
      Tcl_Obj key=tcl.ObjIndex(names,t);
      PrintFormat("   tcl_platform(%s):%s",tcl.String(key),tcl.String(tcl.Get(tcl_platform,key)) );
    }
    tcl.Unref(tcl_platform);
    tcl.Unref(names);
  }
  delete tcl;
  ATcl_OnDeinit();
}

