//+------------------------------------------------------------------+
//|                                                      oostack.mq4 |
//|                                                Maxim A.Kuznetsov |
//|                                                      luxtrade.tk |
//+------------------------------------------------------------------+
#property copyright "Maxim A.Kuznetsov"
#property link      "luxtrade.tk"
#property version   "1.00"
#property strict
#property script_show_inputs
#property description "ATcl demo"
#property description "---------"
#property description "This script show howto use Object Orientation with Tcl & MQL "

#include <ATcl\\ATcl.mqh>
ATcl *tcl;

class Stack {
protected:
   Tcl_Obj obj;
public:
   Stack() {
      obj=tcl.ObjEval("Stack new");
      tcl.Ref(obj);
   }
   ~Stack() {
      tcl.Call(obj,tcl.Obj("destroy"));
      tcl.Unref(obj);
   }
   void Push(string s) {
      tcl.Call(obj,tcl.Obj("Push"),tcl.Obj(s));
   }
   string Pop() {
      return tcl.StringCall(obj,tcl.Obj("Pop"));
   }
};

void OnStart()
{
   ATcl_OnInit();
   tcl=new ATcl;
   if (tcl!=NULL && tcl.Ready()) {
      if (tcl.Eval("source MQL4/Files/ATcl/Stack.tcl")!=TCL_OK) {
         PrintFormat("Error: %s",tcl.StringResult());
      } else {
         Stack stack;
         stack.Push("hello");
         stack.Push("word");
         PrintFormat("pop: %s",stack.Pop());
         PrintFormat("pop: %s",stack.Pop());
      }
   }
   delete tcl;
   ATcl_OnDeinit();
}

